const { Shell, St } = imports.gi;
const AppDisplay = imports.ui.appDisplay;
const PopupMenu = imports.ui.popupMenu;
const Main = imports.ui.main;
const appSys = Shell.AppSystem.get_default();
function addPopup(info, widget) {
    if (!AppDisplay.discreteGpuAvailable)
        return;
    const menu = new PopupMenu.PopupMenu(widget, 0.0, St.Side.TOP, 0);
    Main.uiGroup.add_actor(menu.actor);
    menu.actor.hide();
    menu.actor.add_style_class_name('panel-menu');
    const appPrefersNonDefaultGPU = info.app_info.get_boolean('PrefersNonDefaultGPU');
    const gpuPref = appPrefersNonDefaultGPU
        ? Shell.AppLaunchGpu.DEFAULT
        : Shell.AppLaunchGpu.DISCRETE;
    const menu_item = appendMenuItem(menu, appPrefersNonDefaultGPU
        ? _('Launch using Integrated Graphics Card')
        : _('Launch using Discrete Graphics Card'));
    menu_item.connect('activate', () => {
        var _a;
        (_a = appSys.lookup_desktop_wmclass(info.id())) === null || _a === void 0 ? void 0 : _a.launch(0, -1, gpuPref);
    });
    widget.connect('button-press-event', (_, event) => {
        if (event.get_button() === 3) {
            menu.toggle();
        }
    });
}
function appendMenuItem(menu, label) {
    let item = new PopupMenu.PopupMenuItem(label);
    menu.addMenuItem(item);
    return item;
}
