const Me = imports.misc.extensionUtils.getCurrentExtension();
const plugins = Me.imports.launcher_plugins;
const service = Me.imports.launcher_service;
var ShellBuiltin = class ShellBuiltin extends plugins.Builtin {
    constructor() {
        super(...arguments);
        this.selections = [];
    }
    init() { }
    query(ext, _) {
        var _a;
        this.selections.splice(0);
        let id = 0;
        const files = new Map([[service.BUILTIN_FILES.config.name, service.BUILTIN_FILES]]);
        for (const map of [files, ext.window_search.service.plugins]) {
            for (const [name, service] of map) {
                if (((_a = service.config.pattern) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                    const example = service.config.examples
                        ? service.config.examples
                        : service.config.pattern;
                    this.selections.push({
                        id,
                        name,
                        description: service.config.description + `: ${example}`,
                        fill: service.config.fill
                    });
                    id += 1;
                }
            }
        }
        return {
            event: "queried",
            selections: this.selections
        };
    }
    submit(_, id) {
        const selection = this.selections[id];
        let text = "";
        if (selection) {
            if (selection.fill) {
                text = selection.fill;
            }
        }
        return { event: "fill", text };
    }
}
